ccollect/ccollect.sh

516 lines
11 KiB
Bash
Raw Normal View History

2005-11-17 11:33:49 +00:00
#!/bin/sh
# Nico Schottelius
# written for SyGroup (www.sygroup.ch)
# Date: Mon Nov 14 11:45:11 CET 2005
# Last Modified: (See ls -l or git)
2005-11-17 11:33:49 +00:00
#
2005-12-06 14:55:07 +00:00
# where to find our configuration and temporary file
#
CCOLLECT_CONF=${CCOLLECT_CONF:-/etc/ccollect}
CSOURCES=$CCOLLECT_CONF/sources
CDEFAULTS=$CCOLLECT_CONF/defaults
CPREEXEC="$CDEFAULTS/pre_exec"
CPOSTEXEC="$CDEFAULTS/post_exec"
2005-12-06 14:55:07 +00:00
TMP=$(mktemp /tmp/$(basename $0).XXXXXX)
2006-11-14 22:35:10 +00:00
VERSION=0.5.2
2006-10-19 22:25:06 +00:00
RELEASE="2006-XXXXX"
2006-01-24 21:36:28 +00:00
HALF_VERSION="ccollect $VERSION"
FULL_VERSION="ccollect $VERSION ($RELEASE)"
#
# Date
# CDATE: how we use it for naming of the archives
# DDATE: how the user should see it in our output
#
CDATE="date +%Y-%m-%d-%H%M"
DDATE="date"
#
# unset parallel execution
#
PARALLEL=""
2005-12-06 14:55:07 +00:00
#
# catch signals
#
trap "rm -f \"$TMP\"" 1 2 15
2005-11-17 11:33:49 +00:00
add_name()
{
sed "s:^:\[$name\] :"
}
#
2005-12-06 12:45:37 +00:00
# Tell how to use us
#
2005-12-06 12:45:37 +00:00
usage()
{
echo "$(basename $0): <interval name> [args] <sources to backup>"
2005-12-06 12:45:37 +00:00
echo ""
2006-01-24 21:36:28 +00:00
echo " ccollect creates (pseudo) incremental backups"
2005-12-06 12:45:37 +00:00
echo ""
echo " -h, --help: Show this help screen"
2006-01-24 21:58:39 +00:00
echo " -p, --parallel: Parallelise backup processes"
2005-12-06 14:35:29 +00:00
echo " -a, --all: Backup all sources specified in $CSOURCES"
2006-01-24 21:58:39 +00:00
echo " -v, --verbose: Be very verbose (uses set -x)."
2005-12-06 12:45:37 +00:00
echo ""
2006-02-05 17:56:36 +00:00
echo " This is version $VERSION, released on ${RELEASE}"
echo " (the first version was written on 2005-12-05 by Nico Schottelius)."
2006-01-24 21:58:39 +00:00
echo ""
2006-10-15 19:56:55 +00:00
echo " Retrieve latest ccollect at http://unix.schottelius.org/ccollect/"
2005-12-06 12:45:37 +00:00
exit 0
}
#
# need at least interval and one source or --all
#
if [ $# -lt 2 ]; then
usage
fi
#
# check for configuraton directory
#
if [ ! -d "$CCOLLECT_CONF" ]; then
echo "No configuration found in \"$CCOLLECT_CONF\"" \
" (is \$CCOLLECT_CONF properly set?)"
exit 1
fi
2005-12-06 12:45:37 +00:00
#
# Filter arguments
#
INTERVAL=$1; shift
2005-12-06 12:45:37 +00:00
i=1
2006-04-29 10:58:57 +00:00
no_sources=0
2005-12-06 12:45:37 +00:00
while [ $i -le $# ]; do
eval arg=\$$i
2006-10-25 12:48:48 +00:00
if [ "$NO_MORE_ARGS" = 1 ]; then
2006-04-29 10:58:57 +00:00
eval source_${no_sources}=\"$arg\"
no_sources=$(($no_sources+1))
else
case $arg in
-a|--all)
ALL=1
;;
2005-12-08 15:14:46 +00:00
-v|--verbose)
VERBOSE=1
;;
-p|--parallel)
PARALLEL="1"
;;
-h|--help)
usage
;;
--)
NO_MORE_ARGS=1
;;
*)
2006-04-29 10:58:57 +00:00
eval source_${no_sources}=\"$arg\"
no_sources=$(($no_sources+1))
;;
esac
fi
2005-12-06 12:45:37 +00:00
i=$(($i+1))
2005-12-06 12:45:37 +00:00
done
2005-12-08 15:14:46 +00:00
#
# be really, really, really verbose
2005-12-08 15:14:46 +00:00
#
if [ "$VERBOSE" = 1 ]; then
set -x
fi
#
# Look for pre-exec command (general)
#
if [ -x "$CPREEXEC" ]; then
echo "Executing $CPREEXEC ..."
"$CPREEXEC"
2006-10-31 07:18:58 +00:00
ret=$?
echo "Finished ${CPREEXEC}."
2006-10-31 07:18:58 +00:00
if [ $ret -ne 0 ]; then
echo "$CPREEXEC failed, not starting backup."
exit 1
fi
fi
2005-12-06 14:35:29 +00:00
#
# Look, if we should take ALL sources
#
if [ "$ALL" = 1 ]; then
# reset everything specified before
2006-04-29 10:58:57 +00:00
no_sources=0
2006-10-25 12:48:48 +00:00
2005-12-06 14:55:07 +00:00
#
# get entries from sources
#
cwd=$(pwd -P)
cd "$CSOURCES";
2005-12-06 14:55:07 +00:00
ls > "$TMP"
2006-10-15 14:50:12 +00:00
if [ "$?" -ne 0 ]; then
echo "Listing of sources failed. Aborting."
exit 1
fi
2006-10-25 12:48:48 +00:00
2005-12-06 14:55:07 +00:00
while read tmp; do
2006-04-29 10:58:57 +00:00
eval source_${no_sources}=\"$tmp\"
no_sources=$(($no_sources+1))
2005-12-06 14:55:07 +00:00
done < "$TMP"
2005-12-06 14:35:29 +00:00
fi
#
# Need at least ONE source to backup
#
2006-04-29 10:58:57 +00:00
if [ "$no_sources" -lt 1 ]; then
2006-10-25 12:48:48 +00:00
usage
else
echo "==> $HALF_VERSION: Beginning backup using interval $INTERVAL <=="
2005-12-06 14:35:29 +00:00
fi
#
# check default configuration
#
D_FILE_INTERVAL="$CDEFAULTS/intervals/$INTERVAL"
D_INTERVAL=$(cat "$D_FILE_INTERVAL" 2>/dev/null)
#
# Let's do the backup
#
i=0
2006-04-29 10:58:57 +00:00
while [ "$i" -lt "$no_sources" ]; do
2005-11-17 11:33:49 +00:00
#
2006-04-29 10:58:57 +00:00
# Get current source
#
2006-04-29 10:58:57 +00:00
eval name=\$source_${i}
i=$(($i+1))
export name
#
# start ourself, if we want parallel execution
#
if [ "$PARALLEL" ]; then
"$0" "$INTERVAL" "$name" &
continue
fi
#
# Start subshell for easy log editing
#
(
#
# Stderr to stdout, so we can produce nice logs
#
exec 2>&1
#
# Standard locations
#
backup="$CSOURCES/$name"
c_source="$backup/source"
c_dest="$backup/destination"
c_exclude="$backup/exclude"
2005-12-08 10:08:15 +00:00
c_verbose="$backup/verbose"
c_vverbose="$backup/very_verbose"
c_rsync_extra="$backup/rsync_options"
2006-01-24 20:46:49 +00:00
c_summary="$backup/summary"
2006-10-26 08:30:14 +00:00
2006-10-25 13:16:37 +00:00
c_incomplete="$backup/incomplete_remove"
2006-10-31 06:58:00 +00:00
c_marker=".ccollect-${CDATE}.$$"
c_pre_exec="$backup/pre_exec"
c_post_exec="$backup/post_exec"
begin=$($DDATE)
begin_s=$(date +%s)
#
# unset possible options
#
EXCLUDE=""
RSYNC_EXTRA=""
SUMMARY=""
VERBOSE=""
VVERBOSE=""
echo "$begin Beginning to backup"
#
# Standard configuration checks
#
if [ ! -e "$backup" ]; then
echo "Source does not exist."
2006-01-13 16:39:17 +00:00
exit 1
fi
2006-10-25 12:48:48 +00:00
#
# configuration _must_ be a directory
#
if [ ! -d "$backup" ]; then
echo "\"$name\" is not a cconfig-directory. Skipping."
2006-01-13 16:39:17 +00:00
exit 1
fi
#
# first execute pre_exec, which may generate destination or other
# parameters
#
if [ -x "$c_pre_exec" ]; then
2006-10-31 06:58:00 +00:00
echo "Executing ${c_pre_exec} ..."
"$c_pre_exec"
ret=$?
echo "Finished ${c_pre_exec}."
if [ $ret -ne 0 ]; then
echo "$c_pre_exec failed, aborting backup."
exit 1
fi
fi
#
# interval definition: First try source specific, fallback to default
#
c_interval="$(cat "$backup/intervals/$INTERVAL" 2>/dev/null)"
if [ -z "$c_interval" ]; then
c_interval=$D_INTERVAL
if [ -z "$c_interval" ]; then
echo "No definition for interval \"$INTERVAL\" found. Skipping."
2006-01-13 16:39:17 +00:00
exit 1
fi
fi
#
# Source checks
#
if [ ! -f "$c_source" ]; then
2006-01-13 16:39:17 +00:00
echo "Source description $c_source is not a file. Skipping."
exit 1
else
source=$(cat "$c_source")
if [ $? -ne 0 ]; then
echo "Skipping: Source $c_source is not readable"
2006-01-13 16:39:17 +00:00
exit 1
fi
fi
#
# destination _must_ be a directory
#
if [ ! -d "$c_dest" ]; then
2006-01-13 16:39:17 +00:00
echo "Destination $c_dest does not link to a directory. Skipping"
exit 1
fi
#
# exclude list
#
if [ -f "$c_exclude" ]; then
EXCLUDE="--exclude-from=$c_exclude"
fi
2006-10-25 12:48:48 +00:00
#
# extra options for rsync
#
if [ -f "$c_rsync_extra" ]; then
RSYNC_EXTRA="$(cat "$c_rsync_extra")"
fi
2006-10-25 12:48:48 +00:00
#
2006-01-24 20:46:49 +00:00
# Output a summary
#
2006-01-24 20:46:49 +00:00
if [ -f "$c_summary" ]; then
SUMMARY="--stats"
fi
2006-10-25 12:48:48 +00:00
#
# Verbosity for rsync
#
2006-03-19 00:10:58 +00:00
if [ -f "$c_verbose" ]; then
VERBOSE="-v"
fi
2006-10-25 12:48:48 +00:00
#
2006-01-22 09:46:58 +00:00
# MORE verbosity, includes standard verbosity
#
if [ -f "$c_vverbose" ]; then
2006-01-22 09:46:58 +00:00
VERBOSE="-v"
VVERBOSE="-v"
fi
2006-10-25 12:48:48 +00:00
2006-10-25 13:16:37 +00:00
#
# show if we shall remove partial backup, and whether the last one
# is incomplete or not
#
2006-10-31 06:58:00 +00:00
# FIXME: test general for incomplete and decide only for warn|delete based on option?
2006-10-25 13:16:37 +00:00
if [ -f "$c_incomplete" ]; then
last_dir=$(ls -d "$c_dest/${INTERVAL}."?* 2>/dev/null | sort -n | tail -n 1)
# check whether the last backup was incomplete
# STOPPED HERE
# todo: implement rm -rf, implement warning on non-cleaning
# implement the marknig and normal removing
if [ "$last_dir" ]; then
incomplete=$(cd "$last_dir" && ls .ccollect-????-??-)
if [ "$incomplete" ]; then
"Removing incomplete backup $last_dir ..."
2006-10-31 06:58:00 +00:00
echo rm -rf $VVERBOSE "$last_dir"
2006-10-25 13:16:37 +00:00
fi
fi
fi
#
# check if maximum number of backups is reached, if so remove
#
2006-10-25 12:48:48 +00:00
# the created directories are named $INTERVAL-$DATE-$TIME.$PID
2006-11-14 22:35:10 +00:00
count=$(cd "$c_dest" && ls -p1 | grep "^${INTERVAL}\..*/\$" | wc -l | sed 's/^ *//g')
2006-02-05 23:25:30 +00:00
echo -n "Currently $count backup(s) exist(s),"
echo " total keeping $c_interval backup(s)."
2006-10-25 12:48:48 +00:00
if [ "$count" -ge "$c_interval" ]; then
2006-10-15 19:01:28 +00:00
substract=$((${c_interval} - 1))
remove=$(($count - $substract))
2006-01-13 16:39:17 +00:00
echo "Removing $remove backup(s)..."
ls -d "$c_dest/${INTERVAL}."?* | sort -n | head -n $remove > "$TMP"
2006-11-14 22:35:10 +00:00
#( cd "$c_dest" && ls -p1 | grep "^${INTERVAL}\..*/\$" | sort -n | head -n $remove > "$TMP"
while read to_remove; do
dir="$to_remove"
2006-01-13 16:39:17 +00:00
echo "Removing $dir ..."
rm $VVERBOSE -rf "$dir"
done < "$TMP"
fi
2006-10-25 12:48:48 +00:00
2005-12-06 16:08:38 +00:00
#
# clone the old directory with hardlinks
#
destination_date=$($CDATE)
destination_dir="$c_dest/${INTERVAL}.${destination_date}.$$"
2006-10-25 12:48:48 +00:00
last_dir=$(ls -d "$c_dest/${INTERVAL}."?* 2>/dev/null | sort -n | tail -n 1)
2006-10-25 12:48:48 +00:00
# give some info
2006-01-13 16:39:17 +00:00
echo "Beginning to backup, this may take some time..."
echo "Creating $destination_dir ..."
mkdir $VVERBOSE "$destination_dir" || exit 1
2006-10-25 13:16:37 +00:00
#
2006-10-31 06:58:00 +00:00
# make an absolute path, perhaps $CCOLLECT_CONF is relative!
2006-10-25 13:16:37 +00:00
#
abs_destination_dir="$(cd "$destination_dir" && pwd -P)"
2006-10-25 13:16:37 +00:00
#
2006-10-31 06:58:00 +00:00
# add mark
#
2006-10-31 06:58:00 +00:00
touch "${abs_destination_dir}/${c_marker}"
2005-12-06 16:08:38 +00:00
#
# the rsync part
# options partly stolen from rsnapshot
2005-12-06 16:08:38 +00:00
#
2006-10-25 12:48:48 +00:00
echo "$($DDATE) Transferring files..."
2006-10-15 14:37:07 +00:00
ouropts="-a --delete --numeric-ids --relative --delete-excluded"
useropts="$VERBOSE $EXCLUDE $SUMMARY $RSYNC_EXTRA"
2006-10-15 14:33:32 +00:00
# Clone from previous backup, if existing
if [ "$last_dir" ]; then
2006-10-25 12:48:48 +00:00
#
# This directory MUST be absolute, because rsync does chdir()
# before beginning backup!
#
abs_last_dir="$(cd "$last_dir" && pwd -P)"
if [ -z "$abs_last_dir" ]; then
2006-10-25 13:16:37 +00:00
echo "Changing to the last backup directory failed. I skip this backup."
exit 1
fi
rsync_hardlink="--link-dest=$abs_last_dir"
2006-10-15 14:37:07 +00:00
rsync $ouropts "$rsync_hardlink" $useropts "$source" "$abs_destination_dir"
else
rsync $ouropts $useropts "$source" "$abs_destination_dir"
2006-10-15 14:33:32 +00:00
fi
2006-10-15 14:37:07 +00:00
2006-10-20 09:27:09 +00:00
ret=$?
if [ "$ret" -ne 0 ]; then
echo "rsync reported error $ret. The backup may be broken (see rsync errors)."
fi
2006-10-25 13:16:37 +00:00
#
# FIXME: remove marking here
# rm -f $c_marker
#
echo "$($DDATE) Finished backup"
#
# post_exec
#
if [ -x "$c_post_exec" ]; then
echo "$($DDATE) Executing $c_post_exec ..."
"$c_post_exec"
2006-10-31 07:18:58 +00:00
ret=$?
echo "$($DDATE) Finished ${c_post_exec}."
2006-03-19 00:13:38 +00:00
2006-10-31 07:18:58 +00:00
if [ $ret -ne 0 ]; then
2006-03-19 00:13:38 +00:00
echo "$c_post_exec failed."
fi
fi
end_s=$(date +%s)
2006-10-15 19:01:28 +00:00
full_seconds=$((${end_s} - ${begin_s}))
hours=$(($full_seconds / 3600))
seconds=$(($full_seconds - ($hours * 3600)))
minutes=$(($seconds / 60))
seconds=$((${seconds} - (${minutes} * 60)))
2006-04-28 22:30:02 +00:00
echo "Backup lasted: ${hours}:${minutes}:${seconds} (h:m:s)"
) | add_name
done
2005-12-06 14:55:07 +00:00
2005-12-06 16:08:38 +00:00
#
# Be a good parent and wait for our children, if they are running wild parallel
#
if [ "$PARALLEL" ]; then
echo "$($DDATE) Waiting for child jobs to complete..."
2005-12-06 16:08:38 +00:00
wait
fi
#
# Look for post-exec command (general)
#
if [ -x "$CPOSTEXEC" ]; then
echo "$($DDATE) Executing $CPOSTEXEC ..."
"$CPOSTEXEC"
2006-10-31 07:18:58 +00:00
ret=$?
echo "$($DDATE) Finished ${CPOSTEXEC}."
2006-10-25 12:48:48 +00:00
2006-10-31 07:18:58 +00:00
if [ $ret -ne 0 ]; then
2006-03-19 00:13:38 +00:00
echo "$CPOSTEXEC failed."
fi
fi
2005-12-06 14:55:07 +00:00
rm -f "$TMP"
echo "==> Finished $WE <=="